# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Classes

* [`log4jscanner`](#log4jscanner)

### Tasks

* [`run_scan`](#run_scan): Runs Google's log4jscanner on a target node
* [`run_scan_osx`](#run_scan_osx): Runs Google's log4jscanner on an OSX target node

## Classes

### <a name="log4jscanner"></a>`log4jscanner`

The log4jscanner class.

#### Parameters

The following parameters are available in the `log4jscanner` class:

* [`present`](#present)
* [`linux_directories`](#linux_directories)
* [`linux_skip`](#linux_skip)
* [`scan_data_owner`](#scan_data_owner)
* [`scan_data_group`](#scan_data_group)
* [`cron_user`](#cron_user)
* [`cron_hour`](#cron_hour)
* [`cron_month`](#cron_month)
* [`cron_monthday`](#cron_monthday)
* [`cron_weekday`](#cron_weekday)
* [`cron_minute`](#cron_minute)
* [`windows_directories`](#windows_directories)
* [`windows_skip`](#windows_skip)
* [`scheduled_task_every`](#scheduled_task_every)
* [`osx_directories`](#osx_directories)
* [`osx_skip`](#osx_skip)
* [`ensure`](#ensure)

##### <a name="present"></a>`present`

Whether the scanner should be installed

##### <a name="linux_directories"></a>`linux_directories`

Data type: `Array[String]`

Which directories to scan on Linux nodes

Default value: `['/']`

##### <a name="linux_skip"></a>`linux_skip`

Data type: `Array[String]`

Which directories to skip on Linux nodes

Default value: `['/proc', '/sys', '/tmp']`

##### <a name="scan_data_owner"></a>`scan_data_owner`

Data type: `String`

Owner of the generated scan results

Default value: `'root'`

##### <a name="scan_data_group"></a>`scan_data_group`

Data type: `String`

Group of the generated scan results

Default value: `'root'`

##### <a name="cron_user"></a>`cron_user`

Data type: `String`



Default value: `'root'`

##### <a name="cron_hour"></a>`cron_hour`

Data type: `Any`



Default value: `absent`

##### <a name="cron_month"></a>`cron_month`

Data type: `Any`



Default value: `absent`

##### <a name="cron_monthday"></a>`cron_monthday`

Data type: `Any`



Default value: `absent`

##### <a name="cron_weekday"></a>`cron_weekday`

Data type: `Any`



Default value: `absent`

##### <a name="cron_minute"></a>`cron_minute`

Data type: `Any`



Default value: `fqdn_rand(59)`

##### <a name="windows_directories"></a>`windows_directories`

Data type: `Array[String]`

Which directories to scan on Windows nodes

Default value: `['C:']`

##### <a name="windows_skip"></a>`windows_skip`

Data type: `Array[String]`

Which directories to skip on Windows nodes

Default value: `['C:\Windows\Temp']`

##### <a name="scheduled_task_every"></a>`scheduled_task_every`

Data type: `Integer`

How often the task should run, as a number of days

Default value: `1`

##### <a name="osx_directories"></a>`osx_directories`

Data type: `Array[String]`

Which directories to scan on OSX nodes

Default value: `['/']`

##### <a name="osx_skip"></a>`osx_skip`

Data type: `Array[String]`

Which directories to skip on OSX nodes

Default value: `['/tmp', '/Users/osx', '/dev', '/private/var/db', '/private/var/folders', '/System/Volumes/Data/private/var/db', '/System/Volumes/Data/private/var/folders']`

##### <a name="ensure"></a>`ensure`

Data type: `Enum['present', 'absent']`



Default value: `'present'`

## Tasks

### <a name="run_scan"></a>`run_scan`

Runs Google's log4jscanner on a target node

**Supports noop?** false

#### Parameters

##### `directories`

Data type: `String`

Comma-separated list of directories to search for vulnerable log4j JARs

##### `skip`

Data type: `Optional[String]`

Comma-separated list of glob patterns to skip when scanning (e.g. '/var/run/*')

##### `rewrite`

Data type: `Optional[Boolean]`

Rewrite vulnerable JARs as they are detected

### <a name="run_scan_osx"></a>`run_scan_osx`

Runs Google's log4jscanner on an OSX target node

**Supports noop?** false

#### Parameters

##### `directories`

Data type: `String`

Comma-separated list of directories to search for vulnerable log4j JARs

##### `skip`

Data type: `Optional[String]`

Comma-separated list of glob patterns to skip when scanning (e.g. '/var/run/*')

##### `rewrite`

Data type: `Optional[Boolean]`

Rewrite vulnerable JARs as they are detected

